<template>
  <div>
    <h1>NUESTROS PRODUCTOS</h1>
    <v-row>
      <v-col class="d-flex" cols="12" sm="6" md="3">
        <v-select
          v-model="searchedPrincipalCategory"
          :items="principalCategoriesItems"
          label="Categorias "
          v-on:change="ExecutFuncionalidadSelectPrincipalCategory()"
          dense
        ></v-select>
      </v-col>
    </v-row>

    <v-row>
      <v-col class="d-flex" cols="12" sm="6" md="3">
        <v-select
          v-model="searchedSubCategory"
          v-show="showCategory"
          :items="subCategoriesItems"
          label="Sub-categorias"
          v-on:change="loadProductsFiltredBySubCategories()"
          dense
        ></v-select>
      </v-col>
    </v-row>

    <span v-if="showMessage">Productos Indisponibles</span>

    <v-row v-show="this.showTheGallery">
      <v-col
        cols="12"
        sm="6"
        md="3"
        class="product-boxes"
        v-for="(productItem, index) in productList"
        :key="index"
      >
        <ProductBox
          class="product-box"
          @go-to-this-product-details="goToProductDetails"
          :productItem="productItem"
        />
      </v-col>
    </v-row>
  </div>
</template>

<script>
import ProductBox from "./ProductBox.vue";

import API from "@/API.js";
export default {
  name: "ProductListPage",
  components: {
    ProductBox
  },
  props: {},
  data() {
    return {
      searchedSubCategoryParams: this.$route.params.searchedSubCategory,
      searchedNameParams: this.$route.params.searchedProductName,
      shopCategories: [],
      productprincipalCategories: [],
      productSubCategories: [],
      productList: [],
      searchedPrincipalCategory: "principal-categorias",
      searchedSubCategory: "sub-category",

      searchedProductsName: "null",
      principalCategoriesItems: [],
      subCategoriesItems: [],
      items: [],
      showMessage: false,
      showTheGallery: true,
      showCategory: false
    };
  },
  async mounted() {
    await this.loadProductprincipalCategories();
    if (this.$route.params.filtredPrincipalCategory !== undefined) {
      await this.showProductListFiltredByprincipalCategories();
    } else if (this.searchedNameParams !== undefined) {
      await this.showProductListFiltredSearchedByName();
    } else if (this.searchedSubCategoryParams !== undefined) {
      await this.showProductListFiltredBySubCategories();
    } else {
      await this.loadAllProductList();
    }
    this.showGallery();
    this.filtrateProductprincipalCategories();
  },

  watch: {
    "$route.params.searchedProductName": {
      immediate: true,
      handler: async function() {
        this.productList = await API.searchProductByName(
          this.$route.params.searchedProductName
        );
      }
    }
  },

  methods: {
    async showProductListFiltredByprincipalCategories() {
      this.searchedPrincipalCategory = this.$route.params.filtredPrincipalCategory;
      await this.ExecutFuncionalidadSelectPrincipalCategory();
      this.searchedPrincipalCategory = "principal-categorias";
    },
    async showProductListFiltredSearchedByName() {
      await this.searchProductByName(this.searchedNameParams);
      this.showGallery();
    },
    async showProductListFiltredBySubCategories() {
      this.searchedSubCategory = this.searchedSubCategoryParams;
      await this.loadProductsFiltredBySubCategories();
      this.searchedSubCategoryParams = null;
    },
    async loadAllProductList() {
      this.productList = await API.loadAllProductList();
    },
    filtrateProductprincipalCategories() {
      this.principalCategoriesItems = this.productprincipalCategories.map(
        sweetItem => {
          return sweetItem["principal_category"];
        }
      );
    },
    async loadProductprincipalCategories() {
      this.productprincipalCategories = await API.loadProductprincipalCategories();
    },
    async ExecutFuncionalidadSelectPrincipalCategory() {
      this.showMessage = false;
      this.showTheGallery = true;
      if (this.searchedPrincipalCategory == "Todas") {
        this.productList = await API.loadAllProductList();
        this.showCategory = false;
      } else {
        let searchedPrincipalCategory = this.searchedPrincipalCategory;
        await this.loadProductsFiltredByprincipalCategories(
          searchedPrincipalCategory
        );
        await this.loadProductSubCategories(searchedPrincipalCategory);

        this.subCategoriesItems = this.productSubCategories.map(sweetItem => {
          return sweetItem["sub_category"];
        });

        this.showCategory = true;
        this.showGallery();
      }
    },
    async loadProductsFiltredByprincipalCategories(searchedPrincipalCategory) {
      this.productList = await API.loadProductsFiltredByprincipalCategories(
        searchedPrincipalCategory
      );
    },
    async loadProductSubCategories(searchedPrincipalCategory) {
      this.productSubCategories = await API.loadProductSubCategories(
        searchedPrincipalCategory
      );
    },

    async loadProductsFiltredBySubCategories() {
      let searchedSubCategory = this.searchedSubCategory;

      this.productList = await API.loadProductsFiltredBySubCategories(
        searchedSubCategory
      );
      this.showGallery();
    },
    goToProductDetails(searchedProduct) {
      this.$router.push("/Product-Details/" + searchedProduct);
    },
    async searchProductByName(searchedNameParams) {
      this.productList = await API.searchProductByName(searchedNameParams);
    },

    showGallery() {
      if (this.productList.length === 0) {
        this.showMessage = true;
      } else {
        this.showMessage = false;
      }
    },
    async PutResultLoadProductDetailsEnData() {
      let searchedPrincipalCategory = this.searchedPrincipalCategory;
      this.productList = await API.loadProductsDetailsBysearchedPrincipalCategory(
        searchedPrincipalCategory
      );
      if (this.productList.categoria === "false") {
        this.showThis = true;
        this.galeryHasShow = false;
      }
    }
  }
};
</script>
<style scoped>
.grid {
  display: grid;
  grid-template-columns: repeat(auto-fill, minmax(200px, 1fr));

  column-gap: 12rem;
  place-items: center;
}
.grid > div {
  padding: 1rem;
  display: grid;
  place-items: center;
}
.grid > div::before {
  content: "";
  padding-top: 100%;
  display: block;
  grid-area: 1 / 1 / 2 / 2;
}
body {
  margin: 2rem;
}
.d-flex {
  margin-left: 9%;
}
</style>
